Available in🇮🇳 India
Video Tutorial
Video Tutorial
Watch this video to know how to integrate Razorpay Hosted Checkout on your website.
- Build Integration: Use the sample codes to integrate the Razorpay Hosted Integration on your website.
- Test Integration: Make a test payment using the payment methods configured at checkout to ensure the integration is working as expected.
- Go-live Checklist: Check the go-live checklist before taking the integration live.
1. Build Integration
Follow the steps given below:1 Create an Order in Server
1 Create an Order in Server
Order is an important step in the payment process.
- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
- API Sample Code
- Razorpay Postman Public Workspace
Use this endpoint to create an order using the Orders API.
POST /ordersRequest Parameters
Request Parameters
amount mandatory
: integer The transaction amount, expressed in the currency subunit. For example, for an actual amount of , the value of this field should be 22225.currency mandatory
: string The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Response Parameters
Response Parameters
Descriptions for the response parameters are present in the Orders Entity parameters table.
Error Response Parameters
Error Response Parameters
The error response parameters are available in the API Reference Guide.
2 Pass Payment Options to Hosted Checkout
2 Pass Payment Options to Hosted Checkout
Add the Pay button on your web page using the checkout code given below. The hosted checkout page is displayed when the customers click the Pay button.
2.2 Checkout Options
2.2 Checkout Options
key_id mandatory
: string Enter [YOUR_Key_ID] generated from the Dashboard.name mandatory
: string The business name to be shown in the checkout form.descriptionoptional
: string Description of the item purchased shown in the checkout form.image optional
: string URL of the logo that must appear on the checkout form.order_id mandatory
: string Unique identifier of the Order, created using the Orders API.amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.currency mandatory
: string Currency code for the currency in which you want to accept the payment. For example, INR. Refer to the supported currencies for a list of supported international currencies.Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
method optional
: string Use this parameter to display a specific payment method in Checkout. Possible values:cardnetbankingwalletupipaylater
prefill
: The fields that can be pre-populated in the Checkout form.name optional
: string Name of the cardholder.email mandatory
: string Email address of the customer.contact mandatory
: string Customer’s phone number.notesoptional
: object An additional set of fields that you want to associate with the payment. For example, you can add “shipping address” and “alternate contact” in the Notes field. You can specify up to 15 note fields.Shipping address
: string 106, Razorpay, BangaloreAlternate contact
: string 9000090000callback_url mandatory
: string Page to which the customers are redirected to after a successful payment. razorpay_payment_id, razorpay_order_id and razorpay_signature are sent as form-data through a POST request to the callback_url.Handy TipsCallback URL is not required if you are using the native SDK for Android/iOS.
cancel_urloptional
: string The URL customers are redirected to after the cancellation of a payment.3 Store Fields in Your Server
3 Store Fields in Your Server
A successful payment returns the following fields to the Checkout form.
Success Callback
Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.razorpay_order_id
: string Unique identifier for the order returned by Checkout.razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.4 Verify Payment Signature
4 Verify Payment Signature
This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.
Here are the links to our SDKs for the supported platforms.
To verify the `razorpay_signature` returned to you by the Checkout form:
To verify the `razorpay_signature` returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:
HMAC Hex Digest
- If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Generate Signature on Your Server
Given below is the sample code for payment signature verification:
Post Signature Verification
Post Signature Verification
After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs.
5 Verify Payment Status
5 Verify Payment Status
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:
You can track the payment status in three ways:
- Verify Status from Dashboard
- Subscribe to Webhook Events
- Poll APIs
To verify the payment status from the Razorpay Dashboard:
- Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.

2. Test Integration
After the integration is complete, a Pay button appears on your webpage/app. Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful. You can make test payments using one of the payment methods configured at the Checkout.Supported Payment Methods
Supported Payment Methods
Following are all the payment modes that the customer can use to complete the payment on the Checkout. Some of them are available by default, while others require approval from us. Raise a request from the Dashboard to enable such payment methods.
Netbanking
You can select any of the listed banks. After choosing a bank, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the bank login portals.Check the list of supported banks.UPI
You can enter one of the following UPI IDs:success@razorpay: To make the payment successful.failure@razorpay: To fail the payment.
Handy TipsYou can use Test Mode to test UPI payments, and Live Mode for UPI Intent and QR payments.
Cards
You can use the following test cards to test transactions for your integration in Test Mode.Domestic Cards
Use the following test cards for Indian payments:Check the following lists:
International Cards
Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.Wallet
You can select any of the listed wallets. After choosing a wallet, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the wallet login portals.Check the list of supported wallets.3. Go-live Checklist
Check the go-live checklist for Razorpay Hosted Checkout integration. Consider these steps before taking the integration live.1 Accept Live Payments
1 Accept Live Payments
Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.To generate API Keys in Live Mode on your Razorpay Dashboard:
- Log in to the Razorpay Dashboard and switch to Live Mode on the menu.
- Navigate to Account & Settings → API Keys → Generate Key to generate the API Key for Live Mode.
- Download the keys and save them securely.
- Replace the Test API Key with the Live Key in the Checkout code and start accepting actual payments.
2 Payment Capture
2 Payment Capture
After payment is
authorized, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.- Auto-capture Payments (Recommended)
- Manually Capture Payments
Authorized payments can be automatically captured. You can auto-capture all payments using global settings on the Razorpay Dashboard. Know more about capture settings for payments.
3 Set Up Webhooks
3 Set Up Webhooks
Ensure you have set up webhooks in the live mode and configured the events for which you want to receive notifications.